--- old/usr/src/cmd/zfs/zfs_main.c	2012-10-26 17:09:22.901949000 +0200
+++ new/usr/src/cmd/zfs/zfs_main.c	2012-10-26 17:09:22.910935000 +0200
@@ -252,8 +252,8 @@
 	case HELP_ROLLBACK:
 		return (gettext("\trollback [-rRf] <snapshot>\n"));
 	case HELP_SEND:
-		return (gettext("\tsend [-DnPpRv] [-[iI] snapshot] "
-		    "<snapshot>\n"));
+		return (gettext("\tsend [-DnPpRv] [-[iI] snapshot] <snapshot>\n"
+		    "\tsend -F [-nPRv] [-[iI] snapshot] <snapshot>\n"));
 	case HELP_SET:
 		return (gettext("\tset <property=value> "
 		    "<filesystem|volume|snapshot> ...\n"));
@@ -3521,7 +3521,7 @@
 	boolean_t extraverbose = B_FALSE;
 
 	/* check options */
-	while ((c = getopt(argc, argv, ":i:I:RDpvnP")) != -1) {
+	while ((c = getopt(argc, argv, ":i:I:RDpvnPF")) != -1) {
 		switch (c) {
 		case 'i':
 			if (fromname)
@@ -3556,6 +3556,9 @@
 		case 'n':
 			flags.dryrun = B_TRUE;
 			break;
+		case 'F':
+			flags.far = B_TRUE;
+			break;
 		case ':':
 			(void) fprintf(stderr, gettext("missing argument for "
 			    "'%c' option\n"), optopt);
@@ -3581,6 +3584,11 @@
 		usage(B_FALSE);
 	}
 
+	if (flags.far && (flags.dedup || flags.props)) {
+		(void) fprintf(stderr, gettext("options -D and -p are not "
+		    "allowed with -F\n"));
+		usage(B_FALSE);
+	}
 	if (!flags.dryrun && isatty(STDOUT_FILENO)) {
 		(void) fprintf(stderr,
 		    gettext("Error: Stream can not be written to a terminal.\n"
